View Issue Details

IDProjectCategoryView StatusLast Update
0003051SOGoActiveSyncpublic2015-01-10 07:54
ReporterSigurd Holter Assigned Toludovic  
PrioritynormalSeveritymajorReproducibilityalways
Status resolvedResolutionfixed 
Platform[Server] LinuxOSRHEL/CentOSOS Version7
Product Version2.2.13 
Fixed in Version2.2.14 
Summary0003051: ActiveSync raises exceptions, child terminated with signal 11 after 10 minutes
Description

Using Outlook 2013, SOGo crashes/terminates with signal 11 after 10 minutes.
GDB with breakpoints shows several exceptions are raised before final termination.

Additional Information

Backtrace of one of the exceptions is attached. The others seem similar. I also have a backtrace of the "abort" breakpoint if that helps.

TagsNo tags attached.

Relationships

related to 0003026 resolvedludovic WOWatchDogRequestTimeout stopped working with 2.2.11a 

Activities

Sigurd Holter

Sigurd Holter

2015-01-05 06:26

reporter  

gdb.txt (1,372,414 bytes)
Sigurd Holter

Sigurd Holter

2015-01-05 06:42

reporter   ~0007987

Added backtrace of final abort/signal 11

Sigurd Holter

Sigurd Holter

2015-01-05 06:42

reporter  

gdb.txt.tar.gz (915,872 bytes)
ludovic

ludovic

2015-01-06 08:44

administrator   ~0008005

The trace doesn't show anything relevant.

I suggest you get a support contract (http://inverse.ca/support.html) so we can log in and diagnose the issue directly on the server.

franso6

franso6

2015-01-06 08:47

reporter   ~0008006

I've had a look at the problem: the exception content relates to too many autorelease pools.
I haven't had time to look into it more yet but I can say

  • can replicate with outlook 2013 on initial sync
  • can replicate on iphone iso8 when enabling contacts syncing.
ludovic

ludovic

2015-01-07 14:52

administrator   ~0008017

Try the upcoming nightly builds. A small change was pushed which could affect this.

franso6

franso6

2015-01-08 04:03

reporter   ~0008021

Last edited: 2015-01-08 04:25

View 4 revisions

Thanks for the patch!
I updated to nightly but still no luck.

(gdb) bt -5
#20358 0x00007f213716ed47 in -[NSObject(NGLogs) errorWithFormat:arguments:] (self=0x7f21395461c0, _cmd=<optimized out>, _fmt=0x7f213803ad70, _va=0x7fff4bf996c8) at NSObject+Logs.m:131
#20359 0x00007f213716e7d2 in -[NSObject(NGLogs) errorWithFormat:] (self=0x7f21395461c0, _cmd=<optimized out>, _fmt=0x7f213803ad70) at NSObject+Logs.m:173
#20360 0x00007f2137d265e0 in -[WOWatchDog run:argc:argv:] (self=0x7f21395461c0, _cmd=<optimized out>, newAppName=<optimized out>, newArgC=<optimized out>, newArgV=<optimized out>) at WOWatchDogApplicationMain.m:945
#20361 0x00007f2137d26979 in WOWatchDogApplicationMain (appName=0x7f213929aa60, argc=7, argv=0x7fff4bf999a8) at WOWatchDogApplicationMain.m:1050
#20362 0x00007f2139094579 in main (argc=7, argv=0x7fff4bf999a8, env=0x7fff4bf999e8) at sogod.m:53
(gdb) f 20360
#20360 0x00007f2137d265e0 in -[WOWatchDog run:argc:argv:] (self=0x7f21395461c0, _cmd=<optimized out>, newAppName=<optimized out>, newArgC=<optimized out>, newArgV=<optimized out>) at WOWatchDogApplicationMain.m:945
945 WOWatchDogApplicationMain.m: No such file or directory.
(gdb) po localException->_e_name
NSGenericException
(gdb) ptype localException
type = struct NSException {
private:
struct NSString _e_name;
struct NSString
_e_reason;
void _reserved;
}

(gdb) po localException->_e_reason
Too many (10007) autorelease pools ... leaking them?
(gdb)

version is 2.2.13.20150106-1

what I'm not sure to understand is why the stack is so deep - and not simply crashing the proc.
could the autorelease pool exception be a consequence of an earlier exception that is not handled properly or suppressed improperly?

adding a breakpoint to WOWatchDogApplicationMain.m:945 -> first exception is "Too many (10007) autorelease pools ... leaking them?" with a stack of around 1500 frames already.
Is there a recursive call somewhere that would create a pool at every call ? checking that, I've seen in previous traces that there was a recursive sort somewhere.
It only seems to happen when I enable contacts on my phone, and I've got around 4000 contacts so maybe related to a sort in the contacts handler? Having a look through the code

ludovic

ludovic

2015-01-08 16:05

administrator   ~0008023

The version you use is wrong.

It should be 2.2.13.20150108-1.

Try this version or the upcoming version tonight.

franso6

franso6

2015-01-09 08:10

reporter   ~0008024

sorry didn't pay attention to the date.
The debian wheezy package seems to still 6 Jan though
from http://inverse.ca/debian-nightly/dists/wheezy/wheezy/binary-amd64/Packages

Package: sogo-activesync
Source: sogo
Version: 2.2.13.20150106-1

ludovic

ludovic

2015-01-09 08:37

administrator   ~0008025

Retry.

franso6

franso6

2015-01-09 13:43

reporter   ~0008038

looks ok so far, will attempt the full sync and confirm fixed.
Thanks for the quick turnaround!

franso6

franso6

2015-01-10 02:00

reporter   ~0008046

Sync on the iPhone is working with no problem at all.
Sync on outlook is working but slow. I think it's unrelated to this bug I think --I'll check the doc and mailing list for possible reasons--, so I think this can be closed.
Thanks!

Sigurd Holter

Sigurd Holter

2015-01-10 04:55

reporter   ~0008047

Seems to work now, no 10-minute hangs and no signal 11.
This is with nightly build 20150108.

ludovic

ludovic

2015-01-10 07:54

administrator   ~0008048

Relevant commits:

https://github.com/inverse-inc/sogo/commit/cb9118d869d1d2535c50d46df5457038160de59e

https://github.com/inverse-inc/sogo/commit/1cfbea69c14468424f5eb713bcb5918a70b3d676

Issue History

Date Modified Username Field Change
2015-01-05 06:26 Sigurd Holter New Issue
2015-01-05 06:26 Sigurd Holter File Added: gdb.txt
2015-01-05 06:42 Sigurd Holter Note Added: 0007987
2015-01-05 06:42 Sigurd Holter File Added: gdb.txt.tar.gz
2015-01-06 08:44 ludovic Note Added: 0008005
2015-01-06 08:47 franso6 Note Added: 0008006
2015-01-07 14:52 ludovic Note Added: 0008017
2015-01-08 04:03 franso6 Note Added: 0008021
2015-01-08 04:16 franso6 Note Edited: 0008021 View Revisions
2015-01-08 04:25 franso6 Note Edited: 0008021 View Revisions
2015-01-08 04:25 franso6 Note Edited: 0008021 View Revisions
2015-01-08 16:05 ludovic Note Added: 0008023
2015-01-09 06:22 Christian Mack Relationship added related to 0003026
2015-01-09 08:10 franso6 Note Added: 0008024
2015-01-09 08:37 ludovic Note Added: 0008025
2015-01-09 13:43 franso6 Note Added: 0008038
2015-01-10 02:00 franso6 Note Added: 0008046
2015-01-10 04:55 Sigurd Holter Note Added: 0008047
2015-01-10 05:17 ludovic Status new => resolved
2015-01-10 05:17 ludovic Fixed in Version => 2.2.14
2015-01-10 05:17 ludovic Resolution open => fixed
2015-01-10 05:17 ludovic Assigned To => ludovic
2015-01-10 07:54 ludovic Note Added: 0008048